<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Payments_TransferGeofencesResponse StructType
 * @subpackage Structs
 */
class Payments_TransferGeofencesResponse extends AbstractStructBase
{
    /**
     * The error_code
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var int
     */
    public $error_code;
    /**
     * The status
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $status;
    /**
     * The description
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $description;
    /**
     * The transfer_geofences
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \ArrayType\ArrayOfPayments_TransferGeofence
     */
    public $transfer_geofences;
    /**
     * Constructor method for Payments_TransferGeofencesResponse
     * @uses Payments_TransferGeofencesResponse::setError_code()
     * @uses Payments_TransferGeofencesResponse::setStatus()
     * @uses Payments_TransferGeofencesResponse::setDescription()
     * @uses Payments_TransferGeofencesResponse::setTransfer_geofences()
     * @param int $error_code
     * @param string $status
     * @param string $description
     * @param \ArrayType\ArrayOfPayments_TransferGeofence $transfer_geofences
     */
    public function __construct($error_code = null, $status = null, $description = null, \ArrayType\ArrayOfPayments_TransferGeofence $transfer_geofences = null)
    {
        $this
            ->setError_code($error_code)
            ->setStatus($status)
            ->setDescription($description)
            ->setTransfer_geofences($transfer_geofences);
    }
    /**
     * Get error_code value
     * @return int
     */
    public function getError_code()
    {
        return $this->error_code;
    }
    /**
     * Set error_code value
     * @param int $error_code
     * @return \StructType\Payments_TransferGeofencesResponse
     */
    public function setError_code($error_code = null)
    {
        // validation for constraint: int
        if (!is_null($error_code) && !(is_int($error_code) || ctype_digit($error_code))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($error_code, true), gettype($error_code)), __LINE__);
        }
        $this->error_code = $error_code;
        return $this;
    }
    /**
     * Get status value
     * @return string|null
     */
    public function getStatus()
    {
        return $this->status;
    }
    /**
     * Set status value
     * @param string $status
     * @return \StructType\Payments_TransferGeofencesResponse
     */
    public function setStatus($status = null)
    {
        // validation for constraint: string
        if (!is_null($status) && !is_string($status)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($status, true), gettype($status)), __LINE__);
        }
        $this->status = $status;
        return $this;
    }
    /**
     * Get description value
     * @return string|null
     */
    public function getDescription()
    {
        return $this->description;
    }
    /**
     * Set description value
     * @param string $description
     * @return \StructType\Payments_TransferGeofencesResponse
     */
    public function setDescription($description = null)
    {
        // validation for constraint: string
        if (!is_null($description) && !is_string($description)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($description, true), gettype($description)), __LINE__);
        }
        $this->description = $description;
        return $this;
    }
    /**
     * Get transfer_geofences value
     * @return \ArrayType\ArrayOfPayments_TransferGeofence|null
     */
    public function getTransfer_geofences()
    {
        return $this->transfer_geofences;
    }
    /**
     * Set transfer_geofences value
     * @param \ArrayType\ArrayOfPayments_TransferGeofence $transfer_geofences
     * @return \StructType\Payments_TransferGeofencesResponse
     */
    public function setTransfer_geofences(\ArrayType\ArrayOfPayments_TransferGeofence $transfer_geofences = null)
    {
        $this->transfer_geofences = $transfer_geofences;
        return $this;
    }
}
